import { select } from 'd3';

export const geneInfoTable = (selection, props) => {
  const {
    full_data,
    inputGeneList
  } = props;  
  
  d3.select("body").append("div")
    .attr("id", "FilterableTable")

  for(var i =0; i<full_data.length; i++){ 
      for (var j =0; j<inputGeneList.length; j++){
          if (full_data[i]['gene'] == inputGeneList[j]['Gene']){
              inputGeneList[j]["level1_len"] = parseInt(full_data[i]["level1"].length)
              inputGeneList[j]["level2_len"] = parseInt(full_data[i]["level2"].length)
              inputGeneList[j]["Gene_name"] = full_data[i]["gene"]
              let temp_str1 = ''
              for(var v=0; v<full_data[i]["level1"].length; v++){
                  if(v == parseInt(full_data[i]["level1"].length) -1){
                      temp_str1 += full_data[i]["level1"][v]
                  }
                  else{
                      temp_str1 += full_data[i]["level1"][v]+', '
                  }
              }
              inputGeneList[i]['level1_list'] = temp_str1            
              let temp_str2 = ''
              for(var v=0; v<full_data[i]["level2"].length; v++){
                  temp_str2 += full_data[i]["level2"][v]
              }
              inputGeneList[i]['level2_list'] = temp_str2
          }
          }

      }

    console.log(Object.keys(inputGeneList[0]));
  	console.log(inputGeneList[0])
		//********* - START TABLE - *********
    var sortAscending = true;
    var table = d3.select('#FilterableTable').append('table');
    
    
    var titles = Object.keys(inputGeneList[0]);
    
    /** sort functionality **/
    var headers = table.append('thead').append('tr')
        .selectAll('th')
        .data(titles).enter()
        .append('th')
        .text(function(d) {
            return d
        })
    
        .on('click', function(d) {
            headers.attr('class', 'header');
            if (d == "Gene_name" || d == "DEG" || d == "level1_list"|| d == "level2_list") { //these keys sort alphabetically
            // sorting alphabetically");
            if (sortAscending) {
                rows.sort(function(a, b) {
                return d3.ascending(a[d], b[d]);
                });
                sortAscending = false;
                this.className = 'aes';
            } else {
                rows.sort(function(a, b) {
                return d3.descending(a[d], b[d]);
            });
         
            sortAscending = true;
            this.className = 'des';
          }
          } else {
          if (sortAscending) {
            //all other keys sort numerically including time
            rows.sort(function(a, b) {
              return b[d] - a[d];
            });
            sortAscending = false;
            this.className = 'aes';
          } else {
            rows.sort(function(a, b) {
              return a[d] - b[d];
            });
            sortAscending = true;
            this.className = 'des';
          }
        }
      });

    var rows = table.append('tbody')
                    .selectAll('tr')
                    .data(inputGeneList)
                    .enter()
                    .append('tr'); 
        
    rows.selectAll('td')
        .data(function(d) {
            return titles.map(function(key, i) {return {
                'value': d[key],
                'name': d
                };
            });
        })
        .enter()
        .append('td')
        .attr('data-th', function(d) {
            return d.name;
        })
        .text(function(d) {return d.value});
};