import { select } from 'd3';
import { cellShape } from './cellShape'
import { loadAndProcessData } from './loadAndProcessData'
import { geneInfoTable } from './geneInfoTable'

const svg = select('svg');
const cellDiagram = svg.append('g');
const YCTable = svg.append('g');

const height = +svg.attr('height');
const width = +svg.attr('width');
const margin = { top: 60, right: 60, bottom: 60, left: 60 };
let full_data;
let locationData
let inputGeneList;

loadAndProcessData().then(data => {
  full_data = data[0];
  locationData = data[1];
  inputGeneList = data[2];
  render();
});

const render = () => {
//   cellDiagram.call(cellShape, {
//     height: height,
//     width: width,
//     margin: margin
//   });
  
  YCTable.call(geneInfoTable, {
    full_data,
    inputGeneList
  });
};