import { select, tsv, json } from 'd3';

let path = document.getElementById('result').value;

// erase later
path = 'https://raw.githubusercontent.com/minwoopak/Gene_cell_location_visualization/master/data/demo_genelist.txt'

export const loadAndProcessData = () =>
  Promise
    .all([
      json('https://raw.githubusercontent.com/minwoopak/Gene_cell_location_visualization/master/data/json_data_mw'),
      tsv(path)
    ])
    .then(([geneLocationDb, demoGeneList]) => {
      let geneInfo;
      geneInfo = geneLocationDb;
      delete demoGeneList.columns;

      const makeLocationData = locname => ({        // data = [{location: , net_DEG: 3}, {location: , net_DEG : 5}]       // d => d.net_DEG
        location: locname,
        net_DEG: 0,
        id: Math.random()
      });

      const makeNewGeneList = geneName => ({
        gene: geneName,
        DEG: 0
      });

      const locationList = ["extracellular space", "plasma membrane", "cytosol", "cytoskeleton", "endoplasmic reticulum", "nucleus", "ribosome", "mitochondrion", "endosome", "lysosome", "peroxisome", "golgi apparatus", "centrosome"];
      let locationData = locationList.map(d => makeLocationData(d));
      
      const selected = demoGeneList.map(d => d.Gene);
      const reducedData = geneLocationDb.filter(el => selected.includes(el.gene));

      let location;
      reducedData.forEach(d => {
        for (location of d.level1) {
          locationData.filter(i => i.location === location)[0]['net_DEG'] += parseFloat(demoGeneList.filter(k => k.Gene === d.gene)[0]['DEG']);
        };
      });
      return [geneLocationDb, locationData, demoGeneList];
  });